unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Forms,
  StdCtrls, ExtCtrls, Mask, 
  Controls, ToolEdit, CurrEdit, ComCtrls, RxCombos;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    RxCalcEdit1: TRxCalcEdit;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Image1: TImage;
    Label1: TLabel;
    Button3: TButton;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    Image2: TImage;
    ColorComboBox1: TColorComboBox;
    TabSheet3: TTabSheet;
    RxCalcEdit2: TRxCalcEdit;
    RxCalcEdit3: TRxCalcEdit;
    RxCalcEdit4: TRxCalcEdit;
    RxCalcEdit5: TRxCalcEdit;
    RxCalcEdit6: TRxCalcEdit;
    RxCalcEdit7: TRxCalcEdit;
    RxCalcEdit8: TRxCalcEdit;
    ColorComboBox2: TColorComboBox;
    ColorComboBox3: TColorComboBox;
    ColorComboBox4: TColorComboBox;
    ColorComboBox5: TColorComboBox;
    ColorComboBox6: TColorComboBox;
    ColorComboBox7: TColorComboBox;
    ColorComboBox8: TColorComboBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Button4: TButton;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure DNSVPR (m: Double; color: TColor);
    procedure DNSVPOL(m: double; color: TColor);
    procedure CenterText(text: string; top: integer);
    function PrintM(y: integer;color: TColor;text: string): integer;
    procedure P707(max: double; fimax: integer; m: double);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses About;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  fnd: integer;
begin
  if RxCalcEdit1.Value<30 then
  begin
    fnd:=0;
    if RxCalcEdit2.Value=RxCalcEdit1.Value then fnd:=fnd+1;
    if RxCalcEdit3.Value=RxCalcEdit1.Value then fnd:=fnd+1;
    if RxCalcEdit4.Value=RxCalcEdit1.Value then fnd:=fnd+1;
    if RxCalcEdit5.Value=RxCalcEdit1.Value then fnd:=fnd+1;
    if RxCalcEdit6.Value=RxCalcEdit1.Value then fnd:=fnd+1;
    if RxCalcEdit7.Value=RxCalcEdit1.Value then fnd:=fnd+1;
    if RxCalcEdit8.Value=RxCalcEdit1.Value then fnd:=fnd+1;
    if fnd=0 then
    begin
      if RxCalcEdit2.Value=0 then RxCalcEdit2.Value:=RxCalcEdit1.Value else
      if RxCalcEdit3.Value=0 then RxCalcEdit3.Value:=RxCalcEdit1.Value else
      if RxCalcEdit4.Value=0 then RxCalcEdit4.Value:=RxCalcEdit1.Value else
      if RxCalcEdit5.Value=0 then RxCalcEdit5.Value:=RxCalcEdit1.Value else
      if RxCalcEdit6.Value=0 then RxCalcEdit6.Value:=RxCalcEdit1.Value else
      if RxCalcEdit7.Value=0 then RxCalcEdit7.Value:=RxCalcEdit1.Value else
      if RxCalcEdit8.Value=0 then RxCalcEdit8.Value:=RxCalcEdit1.Value;
    end;
    Image1.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
    Image2.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
    DNSVPOL(RxCalcEdit1.Value, ColorComboBox1.ColorValue);
    DNSVPR(RxCalcEdit1.Value, ColorComboBox1.ColorValue);
  end
  else
    Application.MessageBox(', ,  !'+chr(13)+chr(10)+'    !','  !',MB_OK);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Image1.Picture.SaveToFile('dn1.bmp');
  Image2.Picture.SaveToFile('dn2.bmp');
end;

procedure TForm1.DNSVPOL(m: double; color: TColor);
var
  gmx, gmy, fi, x1, y1: integer;
  fi1, f, x, y: double;
begin
  gmx:=Image1.Width;
  gmy:=Image1.Height;
  Image1.Canvas.Pen.Color:=clBlack;
  Image1.Canvas.MoveTo(0,gmy div 2-1);
  Image1.Canvas.LineTo(gmx,gmy div 2-1);
  Image1.Canvas.MoveTo(gmx div 2-1,0);
  Image1.Canvas.LineTo(gmx div 2-1,gmy);
  Image1.Canvas.Pen.Color:=color;
  Image1.Canvas.MoveTo(gmx div 2,gmy div 2);
  for fi:=0 to 360 do
  begin
    fi1:=fi*pi/180;
    if (sin(fi1)<>0) then
      f:=abs((cos(pi*m*cos(fi1))-cos(pi*m))/sin(fi1))
    else
      f:=0;
    x:=f*cos(fi1);
    y:=f*sin(fi1);
    x1:=Trunc(x*100+gmx div 2);
    y1:=Trunc(y*100+gmy div 2);
    if CheckBox1.Checked=true then
      Image1.Canvas.MoveTo(gmx div 2,gmy div 2);
    Image1.Canvas.LineTo(x1,y1);
//    Image1.Canvas.Pixels[x1,y1]:=col;
  end;
end;

procedure TForm1.DNSVPR (m: Double; color: TColor);
var
  max, f, fi1: Double;
  fi, fimax,x1,y1,gmx, gmy: integer;
begin
  gmx:=Image2.Width;
  gmy:=Image2.Height;
  Image2.Canvas.Pen.Color:=clBlack;
  Image2.Canvas.MoveTo(20,gmy);
  Image2.Canvas.LineTo(20,0);
  Image2.Canvas.LineTo(10,20);
  Image2.Canvas.MoveTo(20,0);
  Image2.Canvas.LineTo(30,20);
  Image2.Canvas.MoveTo(0,gmy-40);
  Image2.Canvas.LineTo(gmx,gmy-40);
  Image2.Canvas.LineTo(gmx-20,gmy-30);
  Image2.Canvas.MoveTo(gmx,gmy-40);
  Image2.Canvas.LineTo(gmx-20,gmy-50);
  Image2.Canvas.MoveTo(40,gmy-40);
  Image2.Canvas.Pen.Color:=color;
  max:=0;
  fimax:=0;
  for fi:=0 to 720 do
  begin
    fi1:=fi/2*pi/180;
    if sin(fi1)=0 then
      f:=0
    else
      f:=-abs((cos(pi*m*cos(fi1))-cos(pi*m))/sin(fi1));
    if (max<-f) and (fi<180) then
    begin
      max:=-f;
      fimax:=fi;
    end;
    x1:=fi+20;
    y1:=Trunc(f*120+gmy-40);
    Image2.Canvas.LineTo(x1,y1);
  end;
  P707(max,fimax,m);
end;

procedure TForm1.P707(max: double; fimax: integer; m: double);
var
  df, f, fi1, f1, dfi11: double;
  fi, dfi1, dfi2, x2, y2, x3, gmy: integer;
begin
  gmy:=Image2.Height;
  df:=0.7*max;
  dfi1:=fimax;
  for fi:=fimax downto 1 do
  begin
    fi1:=fi/2*pi/180;
    f:=abs((cos(pi*m*cos(fi1))-cos(pi*m))/sin(fi1));
    if ((f>=df) and (f<=1.058*df)) then
      begin
        dfi1:=fi;
        break;
      end;
  end;
  dfi2:=fimax;
  for fi:=fimax to 360 do
  begin
    fi1:=fi/2*pi/180;
    f:=abs((cos(pi*m*cos(fi1))-cos(pi*m))/sin(fi1));
    if ((f>=df) and (f<=1.058*df)) then
      begin
        dfi2:=fi;
        break;
      end;
  end;
  dfi11:=dfi1/2*pi/180;
//  dfi22:=dfi2*pi/180;
  f1:=-abs((cos(pi*m*cos(dfi11))-cos(pi*m))/sin(dfi11));
  x2:=dfi1+20;
  y2:=Trunc(f1*120+gmy-40);
  x3:=dfi2+20;
  Image2.Canvas.MoveTo(x2,gmy-24);
  Image2.Canvas.LineTo(x2,y2);
  Image2.Canvas.LineTo(x3,y2);
  Image2.Canvas.LineTo(x3,gmy-24);
end;


procedure TForm1.Button3Click(Sender: TObject);
var
  f: TFormAbout;
begin
  f := TFormAbout.Create(Self);
  f.ShowModal;
  f.Close;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  i,y: integer;
begin
  y:=10;
  Image1.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
  Image2.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
  for i:=2 to 7 do
  begin
  if TCheckBox(FindComponent('CheckBox'+IntToStr(i))).Checked and (TRxCalcEdit(FindComponent('RxCalcEdit'+IntToStr(i))).Value>0) and ((TRxCalcEdit(FindComponent('RxCalcEdit'+IntToStr(i))).Value)<30)then
  begin
    DNSVPOL(TRxCalcEdit(FindComponent('RxCalcEdit'+IntToStr(i))).Value, TColorComboBox(FindComponent('ColorComboBox'+IntToStr(i))).ColorValue);
    DNSVPR(TRxCalcEdit(FindComponent('RxCalcEdit'+IntToStr(i))).Value, TColorComboBox(FindComponent('ColorComboBox'+IntToStr(i))).ColorValue);
    y:=PrintM(y,TColorComboBox(FindComponent('ColorComboBox'+IntToStr(i))).ColorValue,TRxCalcEdit(FindComponent('RxCalcEdit'+IntToStr(i))).Text);
  end;
  end;
  Application.MessageBox(' !',' ',MB_OK);
end;

function TForm1.PrintM(y:integer; color:TColor; text:string): integer;
begin
  Image1.Canvas.Font.Color:=color;
  Image1.Canvas.Font.Size:=10;
  Image1.Canvas.TextOut(60,y,'M='+text);
  Image2.Canvas.Font.Color:=color;
  Image2.Canvas.Font.Size:=10;
  Image2.Canvas.TextOut(60,y,'M='+text);
  Result:=y+22;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
  Image2.Canvas.FillRect(Rect(0,0,Image1.Width,Image1.Height));
  Image1.Canvas.Font.Size:=30;
  Image1.Canvas.Font.Name:='Arial';
  Image2.Canvas.Font.Size:=30;
  Image2.Canvas.Font.Name:='Arial';
  CenterText('  ',185);
  CenterText(' ',225);
  Image1.Canvas.Font.Size:=12;
  CenterText('., 2003',420);
end;

procedure TForm1.CenterText(text: string; top: integer);
begin
  Image1.Canvas.TextOut((Image1.Width div 2)-(Image1.Canvas.TextWidth(text) div 2),top,text);
end;

end.
